// demo TREEMAP
// Pierre Cubaud cubaud@cnam.fr 2008

int NSOM = 10000; 
float epsil = 0.1; 
float deltateinte;
float teinte;

int[] pere = new int[NSOM];
int[] poids = new int[NSOM];
int[][] fils = new int[NSOM][NSOM];

void setup(){
// size(1600,1000);
size(800,600);
 colorMode(HSB,360,100,100);
 frameRate(1);
 smooth();
}

void draw(){
 noStroke();
 //stroke(255);
 background(255);
 generation();
 int r = calpoids(0);
 // calcul couleurs de depart
 int i = 0;
 while (fils[0][i] > 0){i++;}
 deltateinte = 360.0/i;
 teinte = 0;
 println(deltateinte);
 dessineFils(0,true,0,0,float(width),float(height));
}

//////////// utilitaires

// generation de l'arbre aleatoire
void generation(){
 for (int i=0; i<NSOM; i++){
   pere[i] = int(random(0,i-1));
   poids[i] = 0;
   for (int j=0; j<NSOM; j++){
    fils[i][j] = -1;
   }
 }
 pere[0] = -1;

 // recherche des fils
 for (int i=0; i<NSOM; i++){
  int n=0;
  for (int j=1; j<NSOM; j++){
    if (pere[j] == i) {fils[i][n]=j;n++;}
  }
 }
}

// calcul des poids
int calpoids(int i){
int pds;
  if (fils[i][0] == -1) {poids[i] = 1; return 1;} // feuille
  else {
   pds = 0;
   for (int j=0; j<NSOM; j++){
     if (fils[i][j] >= 0) pds += calpoids(fils[i][j]);
   }
   poids[i] = pds;
   return pds;
  }
}

void dessineFils(int n, boolean enlargeur,float x, float y, float l, float h){
  if (pere[n] == 0) {teinte =  teinte + int(deltateinte); fill(teinte,100,100); println(n+" : "+teinte);}
  else if (pere[n] > 0) fill(teinte,100*(NSOM-n)/NSOM,100*n/NSOM);//fill(teinte,100*poids[n]/poids[pere[n]],100*(NSOM-n)/NSOM);
  else fill(0,0,0);
  rect(x,y,l,h);
  if (enlargeur) {
   float a = l/poids[n];
   int i = 0;
   while (fils[n][i] > 0){
     float lfils = a*poids[fils[n][i]];
     float hfils = h;
     dessineFils(fils[n][i], false, x+epsil,y+epsil,lfils-2*epsil,hfils-2*epsil);
     i++;
     x += lfils; // y inchang�
   }
  }
  else {
   float a = h/poids[n];
   int i = 0;
   while (fils[n][i] > 0){
     float hfils = a*poids[fils[n][i]];
     float lfils = l;
     dessineFils(fils[n][i], true, x+epsil,y+epsil,lfils-2*epsil,hfils-2*epsil);
     i++;
     y += hfils; // x inchang�
   }
  }
}


